Loading...
Searching...
No Matches
pcl::NormalSpaceSampling< PointT, NormalT > Class Template Reference
Module filters

NormalSpaceSampling samples the input point cloud in the space of normal directions computed at every point. More...

`#include <pcl/filters/normal_space.h>`

Inheritance diagram for pcl::NormalSpaceSampling< PointT, NormalT >:

## Public Types

using | Ptr = shared_ptr<NormalSpaceSampling<PointT, NormalT> >
using | ConstPtr = shared_ptr<const NormalSpaceSampling<PointT, NormalT> >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| NormalSpaceSampling ()
| Empty constructor.
| NormalSpaceSampling (bool extract_removed_indices)
| Constructor.
void | setSample (unsigned int sample)
| Set number of indices to be sampled.
unsigned int | getSample () const
| Get the value of the internal sample parameter.
void | setSeed (unsigned int seed)
| Set seed of random function.
unsigned int | getSeed () const
| Get the value of the internal seed parameter.
void | setBins (unsigned int binsx, unsigned int binsy, unsigned int binsz)
| Set the number of bins in x, y and z direction.
void | getBins (unsigned int &binsx, unsigned int &binsy, unsigned int &binsz) const
| Get the number of bins in x, y and z direction.
void | setNormals (const NormalsConstPtr &normals)
| Set the normals computed on the input point cloud.
NormalsConstPtr | getNormals () const
| Get the normals computed on the input point cloud.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (Indices &indices) override
| Sample of point indices.
bool | initCompute ()
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

unsigned int | sample_
| Number of indices that will be returned.
unsigned int | seed_
| Random number seed.
unsigned int | binsx_
| Number of bins in x direction.
unsigned int | binsy_
| Number of bins in y direction.
unsigned int | binsz_
| Number of bins in z direction.
NormalsConstPtr | input_normals_
| The normals computed at each point in the input cloud.
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT, typename NormalT>
class pcl::NormalSpaceSampling< PointT, NormalT >

NormalSpaceSampling samples the input point cloud in the space of normal directions computed at every point.

Definition at line 51 of file normal_space.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT, typename NormalT>

using pcl::NormalSpaceSampling< PointT, NormalT >::ConstPtr = shared_ptr<const NormalSpaceSampling<PointT, NormalT> >

Definition at line 70 of file normal_space.h.

## Ptr

template<typename PointT, typename NormalT>

using pcl::NormalSpaceSampling< PointT, NormalT >::Ptr = shared_ptr<NormalSpaceSampling<PointT, NormalT> >

Definition at line 69 of file normal_space.h.

## Constructor & Destructor Documentation

## NormalSpaceSampling() [1/2]

template<typename PointT, typename NormalT>

pcl::NormalSpaceSampling< PointT, NormalT >::NormalSpaceSampling | ( |  | ) |

inline

Empty constructor.

Definition at line 73 of file normal_space.h.

References NormalSpaceSampling().

Referenced by NormalSpaceSampling().

## NormalSpaceSampling() [2/2]

template<typename PointT, typename NormalT>

pcl::NormalSpaceSampling< PointT, NormalT >::NormalSpaceSampling | ( | bool | extract_removed_indices | ) |

inline explicit

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed.

Definition at line 78 of file normal_space.h.

References binsx_, binsy_, binsz_, pcl::Filter< PointT >::filter_name_, pcl::FilterIndices< PointT >::FilterIndices(), input_normals_, sample_, and seed_.

## Member Function Documentation

## applyFilter()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Sample of point indices.

Parameters

  [out] | indices | the resultant point cloud indices

Implements pcl::FilterIndices< PointT >.

Definition at line 93 of file normal_space.hpp.

References binsx_, binsy_, binsz_, pcl::Filter< PointT >::extract_removed_indices_, pcl::PCLBase< PointT >::indices_, initCompute(), input_normals_, pcl::Filter< PointT >::removed_indices_, and sample_.

## getBins()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::getBins | ( | unsigned int & | binsx,
|  | unsigned int & | binsy,
|  | unsigned int & | binsz ) const

inline

Get the number of bins in x, y and z direction.

Parameters

  [out] | binsx | number of bins in x direction
  [out] | binsy | number of bins in y direction
  [out] | binsz | number of bins in z direction

Definition at line 133 of file normal_space.h.

References binsx_, binsy_, and binsz_.

## getNormals()

template<typename PointT, typename NormalT>

NormalsConstPtr pcl::NormalSpaceSampling< PointT, NormalT >::getNormals | ( |  | ) | const

inline

Get the normals computed on the input point cloud.

Definition at line 148 of file normal_space.h.

References input_normals_.

## getSample()

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::getSample | ( |  | ) | const

inline

Get the value of the internal sample parameter.

Definition at line 99 of file normal_space.h.

References sample_.

## getSeed()

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::getSeed | ( |  | ) | const

inline

Get the value of the internal seed parameter.

Definition at line 111 of file normal_space.h.

References seed_.

## initCompute()

template<typename PointT, typename NormalT>

bool pcl::NormalSpaceSampling< PointT, NormalT >::initCompute | ( |  | ) |

protected

Definition at line 48 of file normal_space.hpp.

References pcl::PCLBase< PointT >::initCompute(), pcl::PCLBase< PointT >::input_, sample_, and seed_.

Referenced by applyFilter().

## setBins()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::setBins | ( | unsigned int | binsx,
|  | unsigned int | binsy,
|  | unsigned int | binsz )

inline

Set the number of bins in x, y and z direction.

Parameters

  [in] | binsx | number of bins in x direction
  [in] | binsy | number of bins in y direction
  [in] | binsz | number of bins in z direction

Definition at line 120 of file normal_space.h.

References binsx_, binsy_, and binsz_.

## setNormals()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::setNormals | ( | const NormalsConstPtr & | normals | ) |

inline

Set the normals computed on the input point cloud.

Parameters

  [in] | normals | the normals computed for the input cloud

Definition at line 144 of file normal_space.h.

References input_normals_.

## setSample()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::setSample | ( | unsigned int | sample | ) |

inline

Set number of indices to be sampled.

Parameters

  [in] | sample | the number of sample indices

Definition at line 94 of file normal_space.h.

References sample_.

## setSeed()

template<typename PointT, typename NormalT>

void pcl::NormalSpaceSampling< PointT, NormalT >::setSeed | ( | unsigned int | seed | ) |

inline

Set seed of random function.

Parameters

  [in] | seed | the input seed

Definition at line 106 of file normal_space.h.

References seed_.

## Member Data Documentation

## binsx_

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::binsx_

protected

Number of bins in x direction.

Definition at line 157 of file normal_space.h.

Referenced by applyFilter(), getBins(), NormalSpaceSampling(), and setBins().

## binsy_

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::binsy_

protected

Number of bins in y direction.

Definition at line 159 of file normal_space.h.

Referenced by applyFilter(), getBins(), NormalSpaceSampling(), and setBins().

## binsz_

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::binsz_

protected

Number of bins in z direction.

Definition at line 161 of file normal_space.h.

Referenced by applyFilter(), getBins(), NormalSpaceSampling(), and setBins().

## input_normals_

template<typename PointT, typename NormalT>

NormalsConstPtr pcl::NormalSpaceSampling< PointT, NormalT >::input_normals_

protected

The normals computed at each point in the input cloud.

Definition at line 164 of file normal_space.h.

Referenced by applyFilter(), getNormals(), NormalSpaceSampling(), and setNormals().

## sample_

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::sample_

protected

Number of indices that will be returned.

Definition at line 152 of file normal_space.h.

Referenced by applyFilter(), getSample(), initCompute(), NormalSpaceSampling(), and setSample().

## seed_

template<typename PointT, typename NormalT>

unsigned int pcl::NormalSpaceSampling< PointT, NormalT >::seed_

protected

Random number seed.

Definition at line 154 of file normal_space.h.

Referenced by getSeed(), initCompute(), NormalSpaceSampling(), and setSeed().

The documentation for this class was generated from the following files:

- pcl/filters/normal_space.h
- pcl/filters/impl/normal_space.hpp